Subject: bug#74507: closed (Re: bug#74507: [PATCH] Indent compounds c-ts-mode when { is not BOL)

From: [email-masked] (GNU bug Tracking System)
Date: Mon, 02 Dec 2024 02:15:02 +0000

Your bug report

#74507: [PATCH] Indent compounds c-ts-mode when { is not BOL

which was filed against the emacs package, has been closed.

The explanation is attached below, along with your original report.
If you require more details, please reply to [email-masked].

-- 
74507: https://debbugs.gnu.org/cgi/bugreport.cgi?bug=74507
GNU Bug Tracking System
Contact [email-masked] with problems

Subject: Re: bug#74507: [PATCH] Indent compounds c-ts-mode when { is not BOL
From: Yuan Fu <[email-masked]>
To: Jørgen Kvalsvik <[email-masked]>
Cc: Eli Zaretskii <[email-masked]>, Theodor Thornhill <[email-masked]>, [email-masked]
Date: Sun, 1 Dec 2024 18:13:19 -0800
List-Id: <debbugs-submit.debbugs.gnu.org>

> On Dec 1, 2024, at 2:46 PM, Jørgen Kvalsvik <[email-masked]> wrote:
> 
> On 12/1/24 22:48, Yuan Fu wrote:
>>> On Dec 1, 2024, at 1:51 AM, Jørgen Kvalsvik <[email-masked]> wrote:
>>> 
>>> On 12/1/24 10:25, Yuan Fu wrote:
>>>>> On Nov 30, 2024, at 12:49 PM, Jørgen Kvalsvik <[email-masked]> wrote:
>>>>> 
>>>>> On 11/30/24 01:16, Yuan Fu wrote:
>>>>>>> On Nov 29, 2024, at 1:05 AM, Jørgen Kvalsvik <[email-masked]> wrote:
>>>>>>> 
>>>>>>> On 11/29/24 08:57, Eli Zaretskii wrote:
>>>>>>>>> Cc: [email-masked],[email-masked]
>>>>>>>>> From: Jørgen Kvalsvik <[email-masked]>
>>>>>>>>> Date: Sun, 24 Nov 2024 10:15:12 +0100
>>>>>>>>> 
>>>>>>>>> * lisp/progmodes/c-ts-mode.el (c-ts-mode--parent-is-not-top-compound):
>>>>>>>>> New function.
>>>>>>>>> (c-ts-mode--indent-styles): Use it.
>>>>>>>>> * test/lisp/progmodes/c-ts-mode-resources/indent.erts: New compound
>>>>>>>>> statement test.
>>>>>>>> Please make sure the lines here are not too long (see CONTRIBUTE for
>>>>>>>> details).
>>>>>>>>> +(defun c-ts-mode--parent-is-not-top-compound (_n parent &rest _)
>>>>>>>>> +  "Matches when PARENT is not the top level compound statement,
>>>>>>>>> +the {} that immediately follows the signature."
>>>>>>>> The first line of a doc string should be a single complete sentence.
>>>>>>>> Thanks.
>>>>>>> 
>>>>>>> Ok. Yuan, would you like me to submit a revision?
>>>>>> Since your assignment is already done, let’s just apply your patch, and I’ll rebase my changes on top of yours. So yeah, do send the revision patch, thanks!
>>>>>> Yuan
>>>>> 
>>>>> Certainly - I posted it on the bug tracker.
>>>> Thanks Jørgen. What did you use to generate the patch? For some reason I can’t apply it. My git skill isn’t that great so it could be my problem. If you can apply it fine maybe you can share the command you used?
>>> 
>>> I used git format-patch HEAD~1, and I just tested applying it to master with `git am 0001-Indent-compounds-in-c-ts-mode-when-is-not-BOL.patch' which worked.
>>> 
>>>> BTW, the commit title is missing. When you add the title, you can also add the bug number. For example:
>>>> Improve c-ts-mode indentation for macros (bug#74507)
>>>> Yuan
>>> 
>>> Sure. I've attached a new patch with the bug in it. I tested it and it applies cleanly with `git am 0001-Improve-c-ts-mode-compound-indents-bug-74507.patch'
>>> <0001-Improve-c-ts-mode-compound-indents-bug-74507.patch>
>> Thanks. This patch applied without a problem.
>> I reworked your heuristic into a function rule for better organization, and changed the condition slightly:
>> (defun c-ts-mode--macro-heuristic-rules (node parent &rest _)
>>   "Heuristic indent rule for control flow macros.
>> Eg,
>>     #define IOTA(var, n) for (int var = 0; var != (n); ++var)
>>     int main()
>>     {
>>       IOTA (v, 10) {
>>         printf(\"%d \", v);   <-- Here we want to indent
>>         counter++;            <-- Use baseline rule to align
>>     }                             to prev sibling
>> Checked by \"Compound Statement after code (Bug#74507)\" test.
>> NODE and PARENT are the same as other indent rules."
>>   (when (and (treesit-node-match-p parent "compound_statement")
>>              (treesit-node-match-p (treesit-node-prev-sibling parent)
>>                                    "expression_statement"))
>>     (let ((parent-bol
>>            (lambda () (save-excursion
>>                         (goto-char (treesit-node-start parent))
>>                         (back-to-indentation)
>>                         (point)))))
>>       (cond
>>        ;; Closing brace.
>>        ((treesit-node-match-p node "}")
>>         (cons (funcall parent-bol) 0))
>>        ;; First sibling.
>>        ((treesit-node-eq (treesit-node-child parent 0 'named) node)
>>         (cons (funcall parent-bol)
>>               c-ts-mode-indent-offset))))))
>> Instead of checking whether PARENT is top-level compound_statement, I make it check whether the previous sibling is an expression_statement. This way the heuristic works when the macro isn’t at top-level too. Here’s the updated test:
>> #define IOTA(var, n) for (int var = 0; var != (n); ++var)
>> int main()
>> {
>>   IOTA (v, 10) {
>>     printf("%d ", v);
>>   }
>>   const char *msg = "Hello, world!"; {
>>     puts("Hello, world!");
>>   }
>>   for (int i = 0;
>>        i < 10;
>>        i++) {
>>     IOTA (v, 10) {
>>       printf("%d ", v);
>>     }
>>   }
>>   {
>>     IOTA (v, 10) {
>>       printf("%d ", v);
>>     }
>>   }
>> }
>> The only test case that doesn’t pass right now is this one:
>>   const char *msg = "Hello, world!"; {
>>     puts("Hello, world!");
>>   }
>> Is this a real use-case?
>> Yuan
> 
> Maybe - I included it to show that the problem was not tied to it being a macro, but rather { not being the first thing on the line. It would be nice to support it, and c-mode also indents it properly.
> 
> That being said, it is probably rare enough in practice to prio it less.

Ok, I pushed your patch and my indentation rework to master. I end up removing the test mentioned above since it’s not a real use-case, in favor of making the heuristic indent rule more specific.

Yuan

Subject: [PATCH] Indent compounds c-ts-mode when { is not BOL
From: Jørgen Kvalsvik <[email-masked]>
To: [email-masked]
Date: Sun, 24 Nov 2024 10:15:12 +0100
List-Id: <debbugs-submit.debbugs.gnu.org>

Tags: patch

Tags: patch

I found that the coumpounded statements are anchored to the wrong object
when 1. the compound is not at beginning-of-line and 2. it is not
preceeded by a construct such as fndecl/for/if/while/etc., which differs
from how c-mode indents it.

Non-BOL compound statements is actually quite common with macros and
testing frameworks (see the test case). For example, you want this to
indent:

TEST_CASE(1) {
    assert (...);
}

The heuristic is quite course - it simply checks if the grandparent is
function-definition or not, which is really if this node is a top-level
sibling in the function body.  If that is the case, the old rules should
apply and standalone-parent should be the guide; otherwise, it should be
the parent-BOL. This feels a bit shaky but does seem to work well for
the test cases, and can be refined in the future.

>From ad5c50851710711fa1d62708633d7bae92f82fae Mon Sep 17 00:00:00 2001
From: =?UTF-8?q?J=C3=B8rgen=20Kvalsvik?= <[email-masked]>
Date: Tue, 19 Nov 2024 08:01:01 +0100
Subject: [PATCH] Indent compounds c-ts-mode when { is not BOL

Properly indent the body of compound expressions, even when then
compound expression is not at the beginning of line and the parent is
not an if/for/while/etc., and matches the behavior of c-mode.

This fixes a problem that is common with macros and in testing
frameworks. For example, you expect this to indent:

TEST_CASE(1) {
    assert (...);
}

If the compound statement is the function body itself, don't apply this
new rule and instead guide by the parent and first sibling.

I'm sure there are subtle interactions that aren't handled properly by
checking for "function_definition" rather than something more general,
but it does fix the test case and the check can be improved as more
cases are found.

* lisp/progmodes/c-ts-mode.el (c-ts-mode--parent-is-not-top-compound):
New function.
(c-ts-mode--indent-styles): Use it.
* test/lisp/progmodes/c-ts-mode-resources/indent.erts: New compound
statement test.
---
 lisp/progmodes/c-ts-mode.el                   |  8 +++++
 .../progmodes/c-ts-mode-resources/indent.erts | 30 +++++++++++++++++++
 2 files changed, 38 insertions(+)

diff --git a/lisp/progmodes/c-ts-mode.el b/lisp/progmodes/c-ts-mode.el
index 3823c553fda..80233e90241 100644
--- a/lisp/progmodes/c-ts-mode.el
+++ b/lisp/progmodes/c-ts-mode.el
@@ -402,6 +402,11 @@ c-ts-mode--first-sibling
               (treesit-node-start parent)
               (line-end-position))))))
 
+(defun c-ts-mode--parent-is-not-top-compound (_n parent &rest _)
+  "Matches when PARENT is not the top level compound statement,
+the {} that immediately follows the signature."
+  (not (equal "function_definition" (treesit-node-type (treesit-node-parent parent)))))
+
 (defun c-ts-mode--indent-styles (mode)
   "Indent rules supported by `c-ts-mode'.
 MODE is either `c' or `cpp'."
@@ -478,6 +483,7 @@ c-ts-mode--indent-styles
            ;; Closing bracket.  This should be before initializer_list
            ;; (and probably others) rule because that rule (and other
            ;; similar rules) will match the closing bracket.  (Bug#61398)
+           ((and (node-is "}") c-ts-mode--parent-is-not-top-compound) parent-bol 0)
            ((node-is "}") standalone-parent 0)
            ,@(when (eq mode 'cpp)
                '(((node-is "access_specifier") parent-bol 0)
@@ -497,6 +503,8 @@ c-ts-mode--indent-styles
            ((parent-is "field_declaration_list") c-ts-mode--anchor-prev-sibling 0)
 
            ;; Statement in {} blocks.
+           ((and (parent-is "compound_statement") c-ts-mode--parent-is-not-top-compound)
+            parent-bol c-ts-mode-indent-offset)
            ((or (and (parent-is "compound_statement")
                      ;; If the previous sibling(s) are not on their
                      ;; own line, indent as if this node is the first
diff --git a/test/lisp/progmodes/c-ts-mode-resources/indent.erts b/test/lisp/progmodes/c-ts-mode-resources/indent.erts
index 2f3540c3970..61e61677ed7 100644
--- a/test/lisp/progmodes/c-ts-mode-resources/indent.erts
+++ b/test/lisp/progmodes/c-ts-mode-resources/indent.erts
@@ -223,6 +223,36 @@ make_pair(int long_identifier_a[], int long_identifier_b[],
 
 =-=-=
 
+Name: Compound Statement after code
+
+=-=
+#define IOTA(var, n) for (int var = 0; var != (n); ++var)
+int main()
+{
+IOTA (v, 10) {
+printf("%d ", v);
+}
+
+const char *msg = "Hello, world!"; {
+puts("Hello, world!");
+}
+}
+
+=-=
+#define IOTA(var, n) for (int var = 0; var != (n); ++var)
+int main()
+{
+  IOTA (v, 10) {
+    printf("%d ", v);
+  }
+
+  const char *msg = "Hello, world!"; {
+    puts("Hello, world!");
+  }
+}
+
+=-=-=
+
 Name: Switch-Case statement
 
 =-=
-- 
2.39.5